/**
 * @file mousetest.c
 * Test file for mouse driver
 */
#include "vga_text.h"
#include "mouse.h"

void main(void)
{
    int mouse   = 0;
    int buttons = 0;
    int save    = 0;
    
    vgaText_start(16);
    print("Mouse Test Started");
    mouse_start(MOUSE_PROTO_DATA_PIN, MOUSE_PROTO_CLOCK_PIN);
    
    print("\nMouse type ");
    mouse = mouse_present();
    vgaText_dec(mouse);
    print("\n");
    
    while(1) {
        buttons = mouse_buttons() & MOUSE_BUTTON_MASK;
        if (buttons != save)
            print("\r                               ");

        print("\r");
        vgaText_dec(mouse_x());
        print(" ");
        vgaText_dec(mouse_y());
        print(" ");

        if (buttons != save)
        {
            save = buttons;
            if (buttons & MOUSE_LEFT)  
                print("LEFT ");
            if (buttons & MOUSE_RIGHT)  
                print("RIGHT ");
            if (buttons & MOUSE_CENTER)  
                print("CENTER ");
            if (buttons & MOUSE_LEFT_SIDE)  
                print("LEFT SIDE ");
            if (buttons & MOUSE_LEFT_SIDE)  
                print("RIGHT SIDE ");
        }
    }
}
